#ifndef __CY803_H__
#define __CY803_H__

#include <stdint.h>

#define EMU_RAM_SIZE	0x100
#define EMU_RAM_BANKS	0x001

#if (EMU_RAM_BANKS > 4) || (EMU_RAM_BANKS == 0)
	#error EMU_RAM_BANKS incorrect value!
#endif

#define VMRET_OK				0
#define VMRET_UNDEF				1
#define VMRET_HALT				2
#define VMRET_SSC				3
#define VMRET_RETI				4
#define VMRET_RAMBANK_ERR		5
#define VMRET_REG				6

int cy803_init(uint8_t *romaddr);
int cy803_ccall(uint16_t addr, uint8_t argc, uint8_t *argv, uint8_t retc, uint8_t *retv);
int cy803_step(void);

#endif // __CY803_H__
