// lis2bin.c

#include <stdio.h>

typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

DWORD f2b(const char *name, BYTE **ppbuffer, DWORD *psize);

int ishex(char ch)
{
	if ((ch >= '0' && ch <= '9') || (ch >= 'a' && ch <= 'f') || (ch >= 'A' && ch <= 'F'))
	{
		return 1;
	}
	return 0;
}

WORD gethex(char ch)
{
	if (ch >= '0' && ch <= '9')
	{
		ch = ch - '0';
	}
	else if (ch >= 'a' && ch <= 'f')
	{
		ch = ch - 'a' + 10;
	}
	else if (ch >= 'A' && ch <= 'F')
	{
		ch = ch - 'A' + 10;
	}
	return ch;
}

BYTE gethex2(char *buf)
{
	BYTE ret;
	ret = gethex(buf[0]);
	ret <<= 4;
	ret |= gethex(buf[1]);
	return ret;
}

WORD gethex4(char *buf)
{
	WORD ret;
	ret = gethex(buf[0]);
	ret <<= 4;
	ret |= gethex(buf[1]);
	ret <<= 4;
	ret |= gethex(buf[2]);
	ret <<= 4;
	ret |= gethex(buf[3]);
	return ret;
}

BYTE abImage[0x10000];

int main(int n, char **arg)
{
	BYTE *pbData;
	DWORD dwLen;
	DWORD i;
	FILE *f;
	WORD addr;
	
	memset(abImage, 0x00, 0x1000);
	
	if (n != 2) 
	{
		printf("error 1!\n");
		return 1;
	}

	if (f2b(arg[1], &pbData, &dwLen))
	{
		printf("error 2!\n");
		return 2;
	}
	
	i = 0;
	
	while (i < dwLen)
	{
		if (pbData[i] == ' ' && ishex(pbData[i+1]))
		{
			i++;
			addr = gethex4(&pbData[i]);
			i += 4;
			
			i++; // ' '
			
			printf(" %04x: ", addr);
			
			while (ishex(pbData[i]))
			{
				// !
				abImage[addr] = gethex2(&pbData[i]);
				
				printf("%02x ", abImage[addr]);
				
				i+=2;
				addr++;
			}
			printf(" \n");
		}
		while (pbData[i++] != '\n' && i < dwLen);
	}
	
	if ((f = fopen("out.bin", "wb")) == NULL)
	{
		printf("error 3!\n");
		return 3;
	}
	fwrite(abImage, 1, 0x1000, f);
	fclose(f);
	
	return 0;
}


/* File to buffer */
DWORD f2b(const char *name, BYTE **ppbuffer, DWORD *psize)
{
	FILE *f;
	DWORD bsize = 0;
	*psize = 0x00;
	if ((f = fopen(name, "rb")) == 0)
	{
		return 1;
	}
	*ppbuffer = (BYTE*)malloc(1024);
	do
	{
		bsize = fread(&((*ppbuffer)[*psize]), 1, 1024, f);
		*psize += bsize;
		*ppbuffer = (BYTE*)realloc(*ppbuffer, *psize + 1024);
	}
	while (bsize == 1024);
	fclose(f);
	return 0;
}
